vsg: vsg::Options Class Reference

vsg 1.1.3 VulkanSceneGraph library

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Public Attributes | List of all members
vsg::Options Class Reference

Class for passing IO related options to vsg::read/write calls. More...

`#include <Options.h>`

Inheritance diagram for vsg::Options:
[legend]
Collaboration diagram for vsg::Options:
[legend]

## Public Types
enum | FindFileHint { CHECK_ORIGINAL_FILENAME_EXISTS_FIRST , CHECK_ORIGINAL_FILENAME_EXISTS_LAST , ONLY_CHECK_PATHS }
| Hint to use when searching for Paths with vsg::findFile(filename, options);. More...
using | FindFileCallback = std::function<Path(const Path& filename, const Options* options)>

## Public Member Functions
| Options (const Options &options)
template<typename... Args>
| Options (Args... args)
Options & | operator= (const Options &rhs)=delete
int | compare (const Object &rhs) const override
| compare two objects, return -1 if this object is less than rhs, return 0 if it's equal, return 1 if rhs is greater,
virtual bool | readOptions (CommandLine &arguments)
| read command line options, assign values to this options object to later use with reading/writing files
void | read (Input &input) override
void | write (Output &output) const override
void | add (ref_ptr< ReaderWriter > rw={})
void | add (const ReaderWriters &rws)
Public Member Functions inherited from vsg::Inherit< Object, Options >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
void | accept (Visitor &visitor) override
void | accept (ConstVisitor &visitor) const override
void | accept (RecordTraversal &visitor) const override
Public Member Functions inherited from vsg::Object
| Object (const Object &object, const CopyOp &copyop={})
Object & | operator= (const Object &)
template<class T >
T * | cast ()
template<class T >
const T * | cast () const
virtual ref_ptr< Object > | clone (const CopyOp &copyop={}) const
virtual void | traverse (Visitor &)
virtual void | traverse (ConstVisitor &) const
virtual void | traverse (RecordTraversal &) const
void | ref () const noexcept
void | unref () const noexcept
void | unref_nodelete () const noexcept
unsigned int | referenceCount () const noexcept
template<typename T >
void | setValue (const std::string &key, const T &value)
void | setValue (const std::string &key, const char *value)
| specialization of setValue to handle passing C strings
template<typename T >
bool | getValue (const std::string &key, T &value) const
| get specified value type, return false if value associated with key is not assigned or is not the correct type
void | setObject (const std::string &key, ref_ptr< Object > object)
| assign an Object associated with key
Object * | getObject (const std::string &key)
| get Object pointer associated with key, return nullptr if no object associated with key has been assigned
const Object * | getObject (const std::string &key) const
| get const Object pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T >
T * | getObject (const std::string &key)
| get object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T >
const T * | getObject (const std::string &key) const
| get const object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< Object > | getRefObject (const std::string &key)
| get ref_ptr<Object> associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< const Object > | getRefObject (const std::string &key) const
| get ref_ptr<const Object> pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T >
ref_ptr< T > | getRefObject (const std::string &key)
| get ref_ptr<T> of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T >
const ref_ptr< const T > | getRefObject (const std::string &key) const
| get ref_ptr<const T> of specified type associated with key, return nullptr if no object associated with key has been assigned
void | removeObject (const std::string &key)
| remove meta object or value associated with key
Auxiliary * | getOrCreateAuxiliary ()
Auxiliary * | getAuxiliary ()
const Auxiliary * | getAuxiliary () const

## Public Attributes
ref_ptr< SharedObjects > | sharedObjects
ReaderWriters | readerWriters
ref_ptr< OperationThreads > | operationThreads
FindFileHint | checkFilenameHint = CHECK_ORIGINAL_FILENAME_EXISTS_FIRST
Paths | paths
FindFileCallback | findFileCallback
Path | fileCache
Path | extensionHint
bool | mapRGBtoRGBAHint = true
CoordinateConvention | sceneCoordinateConvention = CoordinateConvention::Z_UP
| Coordinate convention to use for scene graph.
std::map< Path, CoordinateConvention > | formatCoordinateConventions
| Coordinate convention to assume for specified lower case file formats extensions.
std::map< std::string, ref_ptr< ShaderSet > > | shaderSets
StateCommands | inheritedState
ref_ptr< Instrumentation > | instrumentation
| Hook for assigning Instrumentation to enable profiling of record traversal.
ref_ptr< FindDynamicObjects > | findDynamicObjects
| mechanism for finding dynamic objects in loaded scene graph
ref_ptr< PropagateDynamicObjects > | propagateDynamicObjects
| mechanism for propogating dynamic objects classification up parental chain so that cloning is done on all dynamic objects to avoid sharing of dyanmic parts.

## Additional Inherited Members
Static Public Member Functions inherited from vsg::Inherit< Object, Options >
static ref_ptr< Options > | create (Args &&... args)
static ref_ptr< Options > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Object
static ref_ptr< Object > | create ()
static ref_ptr< Object > | create_if (bool flag)
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_AFFINTY_OBJECTS
static void | operator delete (void *ptr)
Protected Member Functions inherited from vsg::Object
virtual void | _attemptDelete () const
void | setAuxiliary (Auxiliary *auxiliary)

## Detailed Description

Class for passing IO related options to vsg::read/write calls.

## Member Enumeration Documentation

## ◆ FindFileHint

enum vsg::Options::FindFileHint

Hint to use when searching for Paths with vsg::findFile(filename, options);.

Enumerator
CHECK_ORIGINAL_FILENAME_EXISTS_LAST | check the filename exists with its original path before trying to find it in Options::paths.
ONLY_CHECK_PATHS | check the filename exists with its original path after failing to find it in Options::paths. only check the filename exists in the Options::paths

## Member Function Documentation

## ◆ compare()

int vsg::Options::compare | ( | const Object & | rhs | ) | const
| overridevirtual

compare two objects, return -1 if this object is less than rhs, return 0 if it's equal, return 1 if rhs is greater,

Reimplemented from vsg::Inherit< Object, Options >.

## ◆ read()

void vsg::Options::read | ( | Input & | input | ) |
| overridevirtual

Reimplemented from vsg::Object.

## ◆ write()

void vsg::Options::write | ( | Output & | output | ) | const
| overridevirtual

Reimplemented from vsg::Object.

## Member Data Documentation

## ◆ inheritedState

StateCommands vsg::Options::inheritedState

specification of any StateCommands that will be provided the parents of any newly created subgraphs scene graph creation routines can use the inherited state information to avoid setting state in the local subgraph.

## ◆ shaderSets

std::map<std::string, ref_ptr<ShaderSet> > vsg::Options::shaderSets

User defined ShaderSet map, loaders should check the available ShaderSet using the name of the type of ShaderSet. Standard names are : "pbr" will substitute for vsg::createPhysicsBasedRenderingShaderSet() "phong" will substitute for vsg::createPhongShaderSet() "flat" will substitute for vsg::createFlatShadedShaderSet() "text" will substitute for vsg::createTextShaderSet()

The documentation for this class was generated from the following file:

- include/vsg/io/Options.h